/*
 * Copyright (c) 2019 Tilman Sauerbeck (tilman at code-monkey de)
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

pub const HEIGHT_PX: usize = 70;
pub const WIDTH_PX: usize = 70;

pub const WIDTH_BYTES: usize = (WIDTH_PX as usize + 7) / 8;

pub const SIZE_BYTES: usize = HEIGHT_PX as usize * WIDTH_BYTES;

pub struct Screen {
    pixels: [u8; SIZE_BYTES],
}

impl Screen {
    pub fn new() -> Screen {
        Screen {
            pixels: [0u8; SIZE_BYTES],
        }
    }

    pub fn pixel(&self, index: usize) -> u8 {
        self.pixels[index]
    }

    pub fn blit(&mut self, new_contents: [u8; SIZE_BYTES]) {
        self.pixels = new_contents;
    }
}
